#include <bits/stdc++.h>

const int MAX_NUMBER = 1e5 + 10;

std::vector<int> have, need;
int equal;

void add(int x) {
    if (have[x] == need[x] && need[x] != 0) {
        equal--;
    }
    if (++have[x] == need[x]) {
        equal++;
    }
}

void remove(int x) {
    if (have[x] == need[x]) {
        equal--;
    }
    if (--have[x] == need[x] && need[x] != 0) {
        equal++;
    }
}

int main() {
    freopen("anagrams2.in", "r", stdin);
    freopen("anagrams2.out", "w", stdout);
    int n, m;
    scanf("%d", &n);
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }
    scanf("%d", &m);
    std::vector<int> b(m);
    for (int i = 0; i < m; i++) {
        scanf("%d", &b[i]);
    }
    
    have.resize(MAX_NUMBER + 1, 0);
    need.resize(MAX_NUMBER + 1, 0);
    for (int k = std::min(n, m); k > 0; k--) {
        for (int s = 0; s <= n - k; s++) {
            equal = 0;
            int different = 0;
            for (int i = s; i < s + k; i++) {
                need[a[i]]++;
                different += need[a[i]] == 1;
            }
            for (int i = 0; i < k; i++) {
                add(b[i]);
            }
            if (equal == different) {
                printf("%d %d %d\n", k, s + 1, 1);
                return 0;
            }
            for (int i = 1; i <= m - k; i++) {
                add(b[i + k - 1]);
                remove(b[i - 1]);
                if (equal == different) {
                    printf("%d %d %d\n", k, s + 1, i + 1);
                    return 0;
                }
            }
            for (int i = 1; i <= m - k; i++) {
                remove(b[i + k - 1]);
                add(b[i - 1]);
            }
            for (int i = s; i < s + k; i++) {
                need[a[i]]--;
            }
        }
    }
    printf("0 -1 -1\n");
    return 0;
}
