import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int t = inf.nextInt();
        inf.nextLine();
        for (int i = 1; i <= t; ++i) {
            long cAns = ouf.nextLong();
            long jAns = ans.nextLong();
            ouf.nextLine();
            ans.nextLine();
            if (cAns != jAns)
                return new Outcome(Outcome.Type.WA, String.format("expected: %d, found: %d on query #%d", jAns, cAns, i));
        }
        ouf.close();
        ans.close();
        return new Outcome(Outcome.Type.OK, "All tests is OK");
    }
}
