#include <bits/stdc++.h>

const int max_value = 1000;

int sumk, sumb;

void print_query(int type, int k, int b) {
    printf("%d %d %d\n", type, k, b);
    fflush(stdout);
}

int send_query(int k, int b) {
    print_query(0, k, b);
    int number_of_roots;
    scanf("%d", &number_of_roots);
    if (number_of_roots == -1) {
        print_query(1, -sumk, -sumb);
        exit(0);
    }
    if (number_of_roots == 0) {
        sumk += k;
        sumb += b;
        return 0;
    }
    int sign;
    scanf("%d", &sign);
    assert(sign == -1 || sign == 1);
    sumk += k;
    sumb += b;
    return sign;
}            

int main() {
    send_query(0, -max_value);
    send_query(0, -max_value);
    int signk = send_query(0, 0);
    
    sumk = 0, sumb = 0;
    int leftb = 0, rightb = 4 * max_value + 1;
    while (leftb < rightb - 1) {
        int middleb = (leftb + rightb) / 2;
        send_query(0, middleb - sumb);
        if (send_query(0, 0) == signk) {
            leftb = middleb;
        } else {
            rightb = middleb;
        }
    }
    int b = -leftb + 2 * max_value - (signk == 1);
    send_query(0, 1 - b - sumb + 2 * max_value);
    int leftk = 1, rightk = max_value + 1;
    while (leftk < rightk - 1) {
        int middlek = (leftk + rightk) / 2;
        send_query(middlek * -signk, 0);
        int root_sign = send_query(middlek * signk, 0);
        if (root_sign == 0) {
            int k = middlek * signk;
            printf("1 %d %d\n", k, b);
            fflush(stdout);
            return 0;
        }
        if (root_sign == -signk) {
            leftk = middlek;
        } else {
            rightk = middlek;
        }
    }
    int k = leftk * signk;
    printf("1 %d %d\n", k, b);
    fflush(stdout);
    return 0;
}
