import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;

public class Check implements Checker {
    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String s = inf.nextToken();

        int m = inf.nextInt();
        for (int i = 0; i < m; i++) {
            long expected = ans.nextLong();
            long actual = ouf.nextLong();

            if (expected != actual) {
                return new Outcome(Outcome.Type.WA, String.format("query %d: expected: %d, found: %d", i + 1, expected, actual));
            }
        }

        return new Outcome(Outcome.Type.OK, String.format("%d queries", m));
    }
}
