#include <iostream>
#include <cstring>
#include <string>
#include <cstdio>
using namespace std;

//#define debug(args...) fprintf(stderr, args)
#define debug(args...)
#define prev asdasdasd

int prev[26][100001];
int last[26];

int main()
{
    freopen("minimal.in", "r", stdin);
    freopen("minimal.out", "w", stdout);

    string s;
    cin >> s;

    int n = (int) s.size();
    memset(last, -1, sizeof last);
    for (int i = 0; i < n + 1; i++) {
        for (int j = 0; j < 26; j++) {
            prev[j][i] = last[j];
        }
        if (i < n) last[s[i] - 'a'] = i;
    }

    int m;
    cin >> m;

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        --l; --r;

        int ans = 0;
        int pos = l;
        for (int i = 0; i < 26; i++) {
            int end = prev[i][r + 1];
            if (end != -1) debug("i=%d pos=%d end=%d\n", i, pos, end);
            if (end < l) {
                continue;
            }
            if (end >= pos) {
                debug("go to end, adding %d\n", end - pos);
                ans += end - pos;
                int old_pos = pos;
                pos = end;
                if (prev[i][old_pos] >= l) {
                    end = prev[i][old_pos];
                    debug("Also end=%d\n", end);
                }
            }
            if (end < pos) {
                debug("go to end, adding %d\n", r - pos + end - l + 1);
                ans += r - pos + end - l + 1;
                pos = end;
            }
        }

        cout << ans << "\n";
    }

    return 0;
}
