#include <string>
#include <fstream>
#include <algorithm>
#include <cstring>
using namespace std;

ifstream cin("minimal.in");
ofstream cout("minimal.out");

bool skip[200000];

int main()
{
    string s;
    cin >> s;

    int m;
    cin >> m;

    for (int t = 0; t < m; t++) {
        memset(skip, 0, sizeof skip);
        int l, r;
        cin >> l >> r;
        --l; --r;

        string cur = s.substr(l, r - l + 1);
        sort(cur.begin(), cur.end());
        int pos = 0;
        int ans = 0;
        int i = l;
        while (pos < (int) cur.size()) {
            if (!skip[i]) {
                if (cur[pos] == s[i]) {
                    pos++;
                    skip[i] = true;
                }
            }
            if (pos < (int) cur.size()) ++ans;

            ++i;
            if (i > r) i = l;
        }

        cout << ans << "\n";
    }


    return 0;
}
