import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

import java.util.ArrayList;
import java.util.Arrays;

public class Check implements Checker {

    @Override
    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        int n = inf.nextInt();
        for (int i = 0; i < n; ++i) {
            long tr = ans.nextLong();
            long ct = ouf.nextLong();
            if (tr != ct) {
                return new Outcome(Outcome.Type.WA, String.format("Difference in %d's row: Expected %d, found: %d", i, tr, ct));        
            }
        }        
        return new Outcome(Outcome.Type.OK, String.format("%d lines", n));
    }
}