#include <cstdio>
#include <deque>
#include <iostream>
#include <vector>
using namespace std;

const int MAXN = (int)1e5 + 7;
const int INF = (int)1e9 + 7;

int other(int n)
{
    if (n == 0)
        return 1;
    return 0;
}

int main()
{
    freopen("streets.in", "r", stdin);
    freopen("streets.out", "w", stdout);
    int n, m, k;
    cin >> n >> m >> k;
    int tmp, finish;
    vector<bool> ver(MAXN, false);
    vector<vector<bool>> hor(MAXN, vector<bool>(2, false));
    for (int i = 0; i < n; i++)
        cin >> tmp, hor[tmp][0] = true;
    for (int i = 0; i < m; i++)
        cin >> tmp, hor[tmp][1] = true;
    for (int i = 0; i < k; i++)
        cin >> tmp, ver[tmp] = true;
    cin >> finish;
    
    vector<vector<int>> d(MAXN, vector<int>(2, INF));
    d[0][0] = 0;
    deque<pair<int, int>> deq;
    //first is for coord, second is for line 
    deq.push_back(make_pair(0, 0));
    while (!deq.empty()) 
    {
        int coord = deq.begin()->first;    
        int line = deq.begin()->second;
        deq.pop_front();
        //if (coord <= finish)
        //    cout << coord << ' ' << line << ": ";
        
        //step back
        if (coord > 0 && d[coord - 1][line] > d[coord][line] + hor[coord - 1][line]) 
        {
            //cout << coord - 1 << ' ' << line << "; "; 
            d[coord - 1][line] = d[coord][line] + hor[coord - 1][line];
            deq.push_back(make_pair(coord - 1, line));
        }

        //step front
        if (coord < MAXN - 1 && d[coord + 1][line] > d[coord][line] + hor[coord][line]) 
        {
            //cout << coord + 1 << ' ' << line << "; ";
            d[coord + 1][line] = d[coord][line] + hor[coord][line];
            deq.push_back(make_pair(coord + 1, line));
        }

        //step other line
        if (ver[coord] && d[coord][other(line)] > d[coord][line] + 1) 
        {
            //cout << coord << ' ' << other(line) << "; ";
            d[coord][other(line)] = d[coord][line] + 1;
            deq.push_back(make_pair(coord, other(line)));
        }
        //cout << endl;
    }
    /*for (int l = 0; l < 2; l++) 
    {
        for (int i = 0; i <= finish; i++)
            cout << d[i][l] << ' ';
        cout << endl;
    } */
    cout << d[finish][1];
    return 0;
}