#include <cstdio>
#include <deque>
#include <iostream>
#include <vector>
using namespace std;

const int MAXN = (int)1e5 + 7;
const int INF = (int)1e9 + 7;

int other(int n)
{
    if (n == 0)
        return 1;
    return 0;
}

int main()
{
    freopen("streets.in", "r", stdin);
    freopen("streets.out", "w", stdout);
    int n, m, k;
    cin >> n >> m >> k;
    int tmp, finish;
    vector<bool> ver(MAXN, false);
    vector<vector<bool>> hor(MAXN, vector<bool>(2, false));
    for (int i = 0; i < n; i++)
        cin >> tmp, hor[tmp][0] =  true;
    for (int i = 0; i < m; i++)
        cin >> tmp, hor[tmp][1] =  true;
    for (int i = 0; i < k; i++)
        cin >> tmp, ver[tmp] =  true;
    cin >> finish;
    
    vector<vector<int>> d(MAXN, vector<int>(2, INF));
    vector<vector<bool>> was(MAXN, vector<bool>(2, false));
    d[0][0] = 0;
    was[0][0] = true;
    deque<pair<int, int>> deq;
    //first is for coord, second is for line 
    deq.push_back(make_pair(0, 0));
    while (!deq.empty()) 
    {
        int coord = deq.begin()->first;    
        int line = deq.begin()->second;
        deq.pop_front();
        //cerr << coord << ' ' << line << endl;
        //step back
        if (coord > 0 && !was[coord - 1][line]) 
        {
            d[coord - 1][line] = d[coord][line];
            was[coord - 1][line] = true;
            if (hor[coord - 1][line] == 0) 
                deq.push_front(make_pair(coord - 1, line));
            else
            {
                deq.push_back(make_pair(coord - 1, line));
                d[coord - 1][line]++;
            }
        }

        //step front
        if (coord < finish && !was[coord + 1][line]) 
        {
            d[coord + 1][line] = d[coord][line];
            was[coord + 1][line] = true;
            if (hor[coord][line] == 0) 
                deq.push_front(make_pair(coord + 1, line));
            else
            {
                deq.push_back(make_pair(coord + 1, line));
                d[coord + 1][line]++;
            }
        }

        //step other line
        if (ver[coord] && !was[coord][other(line)]) 
        {
            d[coord][other(line)] = d[coord][line] + 1;
            was[coord][other(line)] = true;
            deq.push_back(make_pair(coord, other(line)));
        }
    }
    cout << d[finish][1];
    return 0;
}