#include <iostream>
#include <cstdio>
using namespace std;
const int N  = 1e5 + 10;
const int INF  = 1e9 + 10;
int dp[2][N];
bool lef[N], rig[N], center[N];

void read(int n, bool* ar) {
    for (int i = 0; i < n; ++i) {
        int x;
        scanf("%d", &x);
        ar[x] = true;
    }
}

int main()
{
    freopen("streets.in", "r", stdin);
    freopen("streets.out", "w", stdout);
    int n, m, k, f;
    cin >> n >> m >> k;
    read(n, lef);
    read(m, rig);
    read(k, center);
    cin >> f;
    for (int i = 0; i < N; ++i)
        dp[0][i] = dp[1][i] = INF;
    dp[0][0] = 0;
    if (center[0]) dp[1][0] = 1;

    for (int i = 1; i < N; ++i) {
        if (lef[i - 1]) dp[0][i] = dp[0][i - 1] + 1;
        else dp[0][i] = dp[0][i - 1];

        if (rig[i - 1]) dp[1][i] = dp[1][i - 1] + 1;
        else dp[1][i] = dp[1][i - 1];
        if (center[i]) {
            dp[0][i] = min(dp[0][i], dp[1][i] + 1);
            dp[1][i] = min(dp[1][i], dp[0][i] + 1);
        }
    }

    int ans = dp[1][f], cur = 0;
    for (int i = f + 1; i < N; ++i) {
        cur += rig[i - 1];
        ans = min(ans, dp[1][i] + cur);
    }
    cout << ans;
    return 0;
}

