#include <fstream>
#include <vector>
using namespace std;

ifstream cin("friends.in");
ofstream cout("friends.out");

#define fail return (cout << "NO\n", 0)

int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    vector<int> b(m);

    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < m; i++) cin >> b[i];

    vector<pair<int, int> > ans;
    for (int i = 0; i < n; i++) {
        vector<char> used(m);
        while (a[i]--) {
            int mx = -1;
            for (int j = 0; j < m; j++) {
                if (!used[j] && (mx == -1 || b[j] > b[mx])) mx = j;
            }
            if (used[mx] || b[mx] == 0) fail;
            used[mx] = true;
            --b[mx];
            ans.push_back(make_pair(i, mx));
        }
    }

    for (int i = 0; i < m; i++) {
        if (b[i] != 0) fail;
    }
    cout << "YES\n";
    cout << ans.size() << "\n";
    for (int i = 0; i < (int) ans.size(); i++) {
        cout << ans[i].first + 1 << " " << ans[i].second + 1 << "\n";
    }
    return 0;
}
