import ru.ifmo.testlib.Checker;
import ru.ifmo.testlib.InStream;
import ru.ifmo.testlib.Outcome;
import static ru.ifmo.testlib.Outcome.Type.*;

public class Check implements Checker {
    public Outcome outcome(Outcome.Type type, final String format) {
        return new Outcome(type, format);
    }

    public Outcome test(InStream inf, InStream ouf, InStream ans) {
        String sAns = ans.nextToken();
        String sOuf = ouf.nextToken();
        if (!sAns.equals(sOuf)) {
            return outcome(WA, String.format("expected %s, found %s", sAns, sOuf));
        }
        return outcome(OK, String.format("%s", sAns));
    }
}
