import java.util.*;
import java.io.*;

public class lcm_ip {
    FastScanner in;
    PrintWriter out;

    final String TASK_NAME = "lcm";

    public void solve() throws IOException {
        int t = in.nextInt();
        for (int it = 0; it < t; ++it) {
            long a = Long.parseLong(in.next());
            long b = Long.parseLong(in.next());
            long mx = 0;
            for (long i = b;; --i) {
                long g = gcd(i, a);
                mx = Math.max(mx, a * i / g);
                if (g == 1)
                    break;
            }
            out.println(mx);
        }
    }

    private long gcd(long x, long y) {
        long t;
        while (x != 0) {
            t = y % x;
            y = x;
            x = t;
        }
        return y;
    }


    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new lcm_ip().run();
    }
}