import java.util.*;
import java.io.*;

public class maxxor_ip_tl {
    FastScanner in;
    PrintWriter out;

    final String TASK_NAME = "maxxor";
    final int MAX_N = 1_000_00;
    final int H = 20;

    public void solve() throws IOException {
        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; ++i)
            a[i] = in.nextInt();

        long ans = 0;
        int l = 0, r = 0;
        for (int i = 0; i < n; ++i) {
            int xr = 0, mx = a[i];
            for (int j = i; j < n; ++j) {
                xr ^= a[j];
                mx = Math.max(a[j], mx);
                long cur = (long) xr * mx;
                if (cur > ans) {
                    ans = cur;
                    l = i;
                    r = j;
                }
            }
        }
        //out.println(l + "-" + r);
        //System.err.println("l r " + l + " " + r);
        out.println(ans);
    }

    public void run() {
        try {
            in = new FastScanner(new File(TASK_NAME + ".in"));
            out = new PrintWriter(new File(TASK_NAME + ".out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new maxxor_ip_tl().run();
    }
}