#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const long long INF = 1000000000000000000LL;
const auto comp = [](pair<int, int> a, pair<int, int> b) {return a.first < b.first || (a.first == b.first && a.second > b.second);};
int n, m, k;
int t[100000];
int h[100000];
long long ans[100000];

int best(int cur_t, int v1, int v2, int v3) {
    long long tv1, tv2, tv3;
    if (v1 != -1) tv1 = (k - (cur_t - t[v1]) % k) % k;
    else tv1 = INF;

    if (v2 != -1) tv2 = (k - (cur_t - t[v2]) % k) % k;
    else tv2 = INF;

    if (v3 != -1) tv3 = (k - (cur_t - t[v3]) % k) % k;
    else tv3 = INF;
    vector<pair<long long, int>> tmp({make_pair(tv1, v1), make_pair(tv2, v2), make_pair(tv3, v3)});
    sort(tmp.begin(), tmp.end());
    return tmp[0].second;    
}

int who_come(int cur_t, set<pair<int, int>, decltype(comp)> const& st) {
    if (st.size() == 0)
        return -1;
    auto tmp = st.upper_bound(make_pair(cur_t%k, n+1));
    int v1 = tmp == st.begin() ? -1 : (*(--tmp)).second;    
    int v2 = st.begin() == st.end() ? -1 : (*(--st.end())).second;
    tmp = st.upper_bound(make_pair(k - cur_t%k - 1, n+1));
    int v3 = tmp == st.begin() ? -1 : (*(--tmp)).second;
    return best(cur_t, v1, v2, v3);        
}

int main() {
    freopen("queue.in", "r", stdin);
    freopen("queue.out", "w", stdout);
    scanf("%d%d%d", &n, &m, &k);
    for (int i = 0; i < n; ++i) {
        scanf("%d%d", &t[i], &h[i]);
    }
    set<pair<int, int>, decltype(comp)> st(comp);
    vector<int> q;
    int p = 0;
    long long cur_time = 0;
    long long sum = 0;
    int i = 0;
    while (1) {
        long long t1 = (int)q.size() == p ? INF : ans[q[p]];
        int who_first = who_come(cur_time, st);
        if (i != n && (who_first == -1 || t[i] < cur_time + (k - (cur_time - t[who_first]) % k) % k))
            who_first = i;
        if (who_first == -1) break;
        long long t2 = who_first == i ? t[who_first] : cur_time + (k - (cur_time - t[who_first]) % k) % k;
        if (t1 <= t2 || (who_first != i && (int)q.size() - p == m)) {
            sum -= h[q[p]];
            cur_time = ans[q[p++]];
        } else {
            if ((int)q.size() - p == m || t2 < cur_time) {
                if (who_first == i) {
                    st.insert(make_pair(k-t[who_first]%k, who_first));
                    cur_time = t[who_first];
                    ++i;   
                }
            } else {
                ans[who_first] = q.size() - p == 0 ? t2 + h[who_first] : (ans[q.back()] + h[who_first]);
                if (who_first != i) {
                    st.erase(make_pair(k-t[who_first]%k, who_first));
                } else {
                    ++i;
                }
                cur_time = t2;
                q.push_back(who_first);
            }          
        }
    }
    for (int i = 0; i < n; ++i) {
        printf("%I64d\n", ans[i]);
    }
    return 0;
}