#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <cstdlib>
#include <cassert>
#include <queue>
#define NAME "queue"
#define mp make_pair
#define pb push_back
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
const int MAXN = 1000003;
 
typedef set <pair <ll, int> > sett;
typedef sett::iterator siter;
 
ll h[MAXN], ans[MAXN];
 
sett s1;
sett s2;
int cn = 0;
ll ac = 0;
 
bool gd(ll x)
{
    return ((x >= 0) && (x <= 1000000000));
}
 
int main() {
    freopen(NAME".in", "r", stdin);
    freopen(NAME".out", "w", stdout);
    ios_base::sync_with_stdio(0);
    int n, m;
    ll k;
    cin >> n >> m >> k;
    assert(max(n, m) <= 1000 * 100);
    assert(gd(k));
    for (int i = 0; i < n;i++)
    {
        ll t;
        cin >> t >> h[i];
        assert(gd(t));
        assert(gd(h[i]));
        s1.insert(mp(t, i));
        ans[i] = -1;
    }
    while (s1.size() != 0)
    {
        ll t = s1.begin()->first;
        int id = s1.begin()->second;
        s1.erase(mp(t, id));
        if (id == -1)
        {
            cn--;
            if (s2.size() == 0) continue;
            siter it = s2.lower_bound(mp(t % k, 0));
            if (it == s2.end()) it = s2.begin();
            ll nt = t - (ll)(t % k) + it->first;
            if (nt < t) nt += k;
            s1.insert(mp(nt, it->second));
            s2.erase(mp(it->first, it->second));
        }
        else if (cn != m)
        {
            ac = max(ac, t) + h[id];
            ans[id] = ac;
            cn++;
            s1.insert(mp(ac, -1));
        }
        else
        {
            s2.insert(mp(t % k, id));
        }
    }
    for (int i = 0; i < n; i++) 
    {
        assert(ans[i] != -1);
        cout << ans[i] << endl;
    }
    return 0;
}