#include "bits/stdc++.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "streets"
 
using namespace std;
typedef long long ll;
typedef pair <int, int> pii;
const int MAXN = 2e5 + 5;
 
int n, m, k;
 
vector <pii> graph[MAXN * 2];
bool used[MAXN * 2];
int a[MAXN], b[MAXN];
 
int main() {        
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);
 
    scanf("%d%d%d", &n, &m, &k);
    assert(1 <= n && n <= 1e5);
    assert(1 <= m && m <= 1e5);
    assert(1 <= k && k <= 1e5);
 
    for (int i = 0; i < n; ++i) {
        int num;
        scanf("%d", &num);
        assert(0 <= num && num <= 1e5);
        a[num] = 1;
        graph[num].puba({num + 1, 1});
        graph[num + 1].puba({num, 1});
    }
 
    for (int i = 0; i < m; ++i) {
        int num;
        scanf("%d", &num);
        assert(0 <= num && num <= 1e5);
        b[num] = 1;
        graph[num + MAXN].puba({num + MAXN + 1, 1});
        graph[num + MAXN + 1].puba({num + MAXN, 1});
    }
 
    for (int i = 0; i < k; ++i) {
        int num;
        scanf("%d", &num);
        assert(0 <= num && num <= 1e5);
        graph[num].puba({num + MAXN, 1});
        graph[num + MAXN].puba({num, 1});
    }
 
    for (int i = 0; i < MAXN - 1; ++i) {
        if (!a[i]) {
            graph[i].puba({i + 1, 0});
            graph[i + 1].puba({i, 0});
        }
        if (!b[i]) {
            graph[i + MAXN].puba({i + 1 + MAXN, 0});
            graph[i + MAXN + 1].puba({i + MAXN, 0});
        }
    }
 
    int f;
    scanf("%d", &f);    
 
    priority_queue <pii> q;
    q.push(mapa(0, 0));
 
    f += MAXN;
 
    while (szof(q)) {
        pii p;
        do {
            p = q.top();
            q.pop();
        } while (szof(q) && used[p.ss]);
        if (used[p.ss]) {
            break;
        }
         
        //cerr << p.ss << " " << -p.ff << endl;
        used[p.ss] = true;
        if (p.ss == f) {
            cout << -p.ff << endl;
            return 0;
        }
 
        for (auto to: graph[p.ss]) {
            if (!used[to.ff]) {                
                q.push({p.ff - to.ss, to.ff});
            }
        }
    }
 
    //cout << -1 << endl;
    assert(false);
     
    return 0;
}